
#include <math.h>

void funcs2D(float t1, float t2, float aa[], float *yy, float dyda[], int na)
{
	int i;
	float eqx,eqy,eqr,prt1,prt2;

	*yy=0.0;
	for (i=1;i<=na-1;i+=8) {
	  eqx=(t1-aa[i+5])*cos(aa[i+4])+(t2-aa[i+6])*sin(aa[i+4]);
	  eqy=(t2-aa[i+6])*cos(aa[i+4])-(t1-aa[i+5])*sin(aa[i+4]);
	  eqr=sqrt(pow(eqx,2.)*pow(1.-aa[i+3],2.)+pow(eqy,2.))/(1.-aa[i+3]);
	  prt1=1.+pow(eqr/aa[i+1],2.);
	  prt2=aa[i]*pow(prt1,-1.*aa[i+2]);
	  *yy += prt2+aa[i+7];
	  dyda[i]=prt2/aa[i];
	  dyda[i+1]=2.*aa[i+2]*prt2*pow(eqr,2.)/(prt1*pow(aa[i+1],3.));
	  dyda[i+2]=-1.*prt2*log(prt1);
	  dyda[i+3]=2.*aa[i+2]*eqx*eqx*prt2/(prt1*aa[i+1]*aa[i+1]);
	  dyda[i+4]=2.*aa[i+2]*prt2*(eqy*((t2-aa[i+6])*sin(aa[i+4])+(t1-aa[i+5])*cos(aa[i+4]))-eqx*(1.-aa[i+3])*(1.-aa[i+3])*((t2-aa[i+6])*cos(aa[i+4])-(t1-aa[i+5])*sin(aa[i+4])))/(prt1*aa[i+1]*aa[i+1]*(1.-aa[i+3]));
	  dyda[i+5]=2.*aa[i+2]*prt2*(eqx*(1.-aa[i+3])*(1.-aa[i+3])*cos(aa[i+4])-eqy*sin(aa[i+4]))/(prt1*aa[i+1]*aa[i+1]*(1.-aa[i+3]));
	  dyda[i+6]=2.*aa[i+2]*prt2*(eqx*(1.-aa[i+3])*(1.-aa[i+3])*sin(aa[i+4])+eqy*cos(aa[i+4]))/(prt1*aa[i+1]*aa[i+1]*(1.-aa[i+3]));
	  dyda[i+7]=1.;
	}
}
